## Index

### Namespaces

- "node:stream/consumers"
- "node:stream/promises"
- AttributeFilterDef
- CompoundFilterDef
- DriverService
- EventEmitter
- FetchByKeysParameters
- ItemMessage
- NestedFilterDef
- WebSocket
- internal

### Enumerations

- Button
- Origin

### Classes

- Actions
- Agent
- Alert
- AlertPromise
- Blob
- Builder
- Builder
- By
- Capabilities
- ClientRequest
- Command
- Condition
- CryptoKey
- Device
- DriverService
- Duplex
- Entry
- EventEmitter
- Executor
- Executor
- FileDetector
- HttpClient
- HttpResponse
- IncomingMessage
- KeyObject
- Keyboard
- Level
- Logs
- Navigation
- Options
- Options
- Options
- Options
- Options
- Options
- OutgoingMessage
- Pointer
- Preferences
- Readable
- RelativeBy
- Request
- Response
- Server
- Server
- Server
- Server
- ServerResponse
- ServiceBuilder
- ServiceBuilder
- ServiceBuilder
- ServiceBuilder
- Session
- ShadowRoot
- ShadowRootPromise
- Socket
- Stream
- TLSSocket
- TargetLocator
- URL
- URLSearchParams
- WebDriver
- WebElement
- WebElementCondition
- WebElementPromise
- WebSocket
- Window
- Writable
- X509Certificate
- internal

### Interfaces

- AddEventListenerOptions
- AddressInfo
- AgentOptions
- ArrayLike
- AsymmetricKeyDetails
- AsyncGenerator
- AsyncGeneratorFunction
- AsyncIterable
- AsyncIterableIterator
- AsyncIterator
- AttributeExprFilter
- AttributeExprFilterDef
- AttributeFilter
- AttributeFilterDef
- BaseDataFilter
- BlobOptions
- Buffer
- BufferConstructor
- CapabilitiesConfiguration
- Certificate
- CipherNameAndProtocol
- ClientRequestArgs
- CloseEvent
- CommonConnectionOptions
- CompoundFilter
- CompoundFilterDef
- ConnectOpts
- ContainsKeysResults
- DOMEventTarget
- DataProvider
- DetailedPeerCertificate
- Dict
- DuplexOptions
- EphemeralKeyInfo
- ErrnoException
- Error
- ErrorEvent
- Event
- Event
- EventEmitter
- EventEmitterOptions
- EventListener
- EventListenerObject
- EventListenerOptions
- EventListenerOptions
- EventTarget
- ExtendedCompoundFilter
- ExtendedCompoundFilterDef
- FetchAttribute
- FetchByKeysParameters
- FetchByKeysResults
- FetchByOffsetParameters
- FetchByOffsetResults
- FetchListParameters
- FetchListResult
- IDirection
- IEntryJSON
- ILocation
- IPerfLoggingPrefs
- IPerfLoggingPrefs
- IRectangle
- ISize
- ITimeouts
- IType
- IWebDriverCookie
- IWebDriverOptionsCookie
- IWebElementId
- IncomingHttpHeaders
- InformationEvent
- IpcSocketConnectOpts
- Item
- ItemMessage
- ItemMetadata
- ItemWithOptionalData
- Iterable
- IterableIterator
- Iterator
- IteratorReturnResult
- IteratorYieldResult
- JsonWebKey
- JwkKeyExportOptions
- KeyExportOptions
- KeyObject
- ListenOptions
- LookupOneOptions
- LookupOptions
- MarshalableBodyAsJSON
- MarshalableBodyAsText
- MarshalableRequestInit
- MarshalableResponseInfo
- MarshaledResponse
- MessageEvent
- NestedFilter
- NestedFilterDef
- NodeEventTarget
- Object
- OnReadOpts
- OutgoingHttpHeaders
- PeerCertificate
- PromiseLike
- ProxyConfig
- PxfObject
- ReadOnlyDict
- ReadWriteStream
- ReadableOptions
- ReadableStream
- ScreenshotManager
- ScreenshotTaker
- SecureContext
- SecureContextOptions
- Serializable
- ServerOptions
- ServerOpts
- ServiceOptions
- SharedArrayBuffer
- SharedArrayBufferConstructor
- SocketConstructorOpts
- SortCriterion
- StaticEventEmitterOptions
- StreamOptions
- SuggestionMetadata
- TLSSocketOptions
- TcpSocketConnectOpts
- TextFilter
- TextFilterDef
- ThenableWebDriver
- Timeouts
- TlsOptions
- WebSocket
- WebSocketAlias
- WritableOptions
- WritableStream
- X509CheckOptions
- ZlibOptions

### Type aliases

- AllowedNames
- ArrayBufferLike
- ArrayBufferView
- BinaryLike
- BodyAs
- BufferEncoding
- ByHash
- ConditionFn
- EventListenerOrEventListenerObject
- Exclude
- Filter
- FilterDef
- FilterFlags
- IteratorResult
- KeyFormat
- KeyObjectType
- KeyType
- Level
- Locator
- LookupFunction
- MarshalableBody
- MarshalableHeaders
- Omit
- OutgoingHttpHeader
- Partial
- Pick
- PropertyKey
- RawData
- Readonly
- Record
- ReferrerPolicy
- RequestCache
- RequestCredentials
- RequestListener
- RequestMode
- RequestRedirect
- ResponseType
- SecureVersion
- ServerOptions
- SocketConnectOpts
- TypedArray
- WithImplicitCoercion

### Variables

- Buffer
- Error
- Event
- EventTarget
- Object
- SharedArrayBuffer
- WebSocket
- WebSocketAlias

## Type aliases

### AllowedNames

AllowedNames<Base, Condition>: FilterFlags<Base, Condition>[keyof Base]

#### Type parameters

- #### Base

- #### Condition

### ArrayBufferLike

ArrayBufferLike: ArrayBufferTypes[keyof ArrayBufferTypes]

### ArrayBufferView

ArrayBufferView: TypedArray | DataView

### BinaryLike

BinaryLike: string | ArrayBufferView

### BodyAs

BodyAs: "json" | "text"

### BufferEncoding

BufferEncoding: "ascii" | "utf8" | "utf-8" | "utf16le" | "ucs2" | "ucs-2" | "base64" | "base64url" | "latin1" | "binary" | "hex"

### ByHash

ByHash: { className: string } | { css: string } | { id: string } | { js: string } | { linkText: string } | { name: string } | { partialLinkText: string } | { tagName: string } | { xpath: string }

Short-hand expressions for the primary element locator strategies. For example the following two statements are equivalent:

    var e1 = driver.findElement(By.id('foo'));
    var e2 = driver.findElement({id: 'foo'});

Care should be taken when using JavaScript minifiers (such as the Closure compiler), as locator hashes will always be parsed using the un-obfuscated properties listed.

### ConditionFn

ConditionFn<T>: (webdriver: WebDriver) => T | null | Promise<T | null>

#### Type parameters

- #### T

#### Type declaration

- - (webdriver: WebDriver): T | null | Promise<T | null>

  - #### Parameters

    - ##### webdriver: WebDriver

    #### Returns T | null | Promise<T | null>

### EventListenerOrEventListenerObject

EventListenerOrEventListenerObject: EventListener | EventListenerObject

### Exclude

Exclude<T, U>: T extends U ? never : T

Exclude from T those types that are assignable to U

#### Type parameters

- #### T

- #### U

### Filter

Filter<D>: AttributeFilter<D> | AttributeExprFilter<D> | CompoundFilter<D> | ExtendedCompoundFilter<D> | NestedFilter<D> | TextFilter<D>

#### Type parameters

- #### D

### FilterDef

FilterDef<D>: AttributeFilterDef<D> | AttributeExprFilterDef<D> | CompoundFilterDef<D> | ExtendedCompoundFilterDef<D> | NestedFilterDef<D> | TextFilterDef

#### Type parameters

- #### D

### FilterFlags

FilterFlags<Base, Condition>: { [ Key in keyof Base]: Base[Key] extends Condition ? Key : never }

#### Type parameters

- #### Base

- #### Condition

### IteratorResult

IteratorResult<T, TReturn>: IteratorYieldResult<T> | IteratorReturnResult<TReturn>

#### Type parameters

- #### T

- #### TReturn = any

### KeyFormat

KeyFormat: "pem" | "der"

### KeyObjectType

KeyObjectType: "secret" | "public" | "private"

### KeyType

KeyType: "rsa" | "rsa-pss" | "dsa" | "ec" | "ed25519" | "ed448" | "x25519" | "x448"

### Level

Level: "FATAL" | "ERROR" | "WARN" | "INFO" | "DEBUG" | "TRACE"

IEDriverServer logging levels.

### Locator

Locator: By | Function | ByHash | RelativeBy

### LookupFunction

LookupFunction: (hostname: string, options: LookupOneOptions, callback: (err: ErrnoException | null, address: string, family: number) => void) => void

#### Type declaration

- - (hostname: string, options: LookupOneOptions, callback: (err: ErrnoException | null, address: string, family: number) => void): void

  - #### Parameters

    - ##### hostname: string

    - ##### options: LookupOneOptions

    - ##### callback: (err: ErrnoException | null, address: string, family: number) => void

      - - (err: ErrnoException | null, address: string, family: number): void

        - #### Parameters

          - ##### err: ErrnoException | null

          - ##### address: string

          - ##### family: number

          #### Returns void

### MarshalableBody

MarshalableBody: MarshalableBodyAsJSON | MarshalableBodyAsText

### MarshalableHeaders

MarshalableHeaders: Record<string, string>

### Omit

Omit<T, K>: Pick<T, Exclude<keyof T, K>>

Construct a type with the properties of T except for those in type K.

#### Type parameters

- #### T

- #### K: keyof any

### OutgoingHttpHeader

OutgoingHttpHeader: number | string | string[]

### Partial

Partial<T>: { [ P in keyof T]?: T[P] }

Make all properties in T optional

#### Type parameters

- #### T

### Pick

Pick<T, K>: { [ P in K]: T[P] }

From T, pick a set of properties whose keys are in the union K

#### Type parameters

- #### T

- #### K: keyof T

### PropertyKey

PropertyKey: string | number | symbol

### RawData

RawData: <internal>.Buffer | ArrayBuffer | <internal>.Buffer[]

Data represents the raw message payload received over the WebSocket.

### Readonly

Readonly<T>: { readonly [ P in keyof T]: T[P] }

Make all properties in T readonly

#### Type parameters

- #### T

### Record

Record<K, T>: { [ P in K]: T }

Construct a type with a set of properties K of type T

#### Type parameters

- #### K: keyof any

- #### T

### ReferrerPolicy

ReferrerPolicy: "" | "no-referrer" | "no-referrer-when-downgrade" | "origin" | "origin-when-cross-origin" | "same-origin" | "strict-origin" | "strict-origin-when-cross-origin" | "unsafe-url"

### RequestCache

RequestCache: "default" | "force-cache" | "no-cache" | "no-store" | "only-if-cached" | "reload"

### RequestCredentials

RequestCredentials: "include" | "omit" | "same-origin"

### RequestListener

RequestListener: (req: IncomingMessage, res: ServerResponse) => void

#### Type declaration

- - (req: IncomingMessage, res: ServerResponse): void

  - #### Parameters

    - ##### req: IncomingMessage

    - ##### res: ServerResponse

    #### Returns void

### RequestMode

RequestMode: "cors" | "navigate" | "no-cors" | "same-origin"

### RequestRedirect

RequestRedirect: "error" | "follow" | "manual"

### ResponseType

ResponseType: "basic" | "cors" | "default" | "error" | "opaque" | "opaqueredirect"

### SecureVersion

SecureVersion: "TLSv1.3" | "TLSv1.2" | "TLSv1.1" | "TLSv1"

### ServerOptions

ServerOptions: SecureContextOptions & TlsOptions & <internal>.ServerOptions

### SocketConnectOpts

SocketConnectOpts: TcpSocketConnectOpts | IpcSocketConnectOpts

### TypedArray

TypedArray: Uint8Array | Uint8ClampedArray | Uint16Array | Uint32Array | Int8Array | Int16Array | Int32Array | BigUint64Array | BigInt64Array | Float32Array | Float64Array

### WithImplicitCoercion

WithImplicitCoercion<T>: T | { valueOf: any }

#### Type parameters

- #### T

## Variables

### Buffer

Buffer: BufferConstructor

### Error

Error: ErrorConstructor

### Event

Event: { AT_TARGET: number; BUBBLING_PHASE: number; CAPTURING_PHASE: number; NONE: number; prototype: <internal>.Event }

#### Type declaration

- ##### Readonly AT_TARGET: number

- ##### Readonly BUBBLING_PHASE: number

- ##### Readonly CAPTURING_PHASE: number

- ##### Readonly NONE: number

- ##### prototype: <internal>.Event

### EventTarget

EventTarget: { prototype: <internal>.EventTarget }

#### Type declaration

- ##### prototype: <internal>.EventTarget

### Object

Object: ObjectConstructor

Provides functionality common to all JavaScript objects.

### SharedArrayBuffer

SharedArrayBuffer: SharedArrayBufferConstructor

### Const WebSocket

WebSocket: typeof <internal>.WebSocketAlias

### Const WebSocketAlias

WebSocketAlias: typeof <internal>.WebSocket

Generated using TypeDoc